/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.support.osgi.tracker.filter;

import java.util.List;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleEvent;
import org.osgi.framework.wiring.BundleCapability;
import org.osgi.framework.wiring.BundleRevision;

public class BundleCapabilityFilter extends AbstractBundleFilter<BundleCapability, BundleCapabilityFilter> {

	public static final String DEFAULT_FILTER_ID = "bundle.capabilities";
	
	protected String namespace;
	
	@Override
	protected String getDefaultFilterId() {
		return DEFAULT_FILTER_ID;
	}
	
	@Override
	public List<BundleCapability> checkBundle(Bundle bundle, BundleEvent event) {
		BundleRevision revision = bundle.adapt(BundleRevision.class);
		if (revision == null)
			return null;
		List<BundleCapability> capabilities = revision.getDeclaredCapabilities(namespace);
		if ((capabilities==null) || (capabilities.size()==0))
			return null;
		return capabilities;
	}

	public void setNamespace(String namespace) {
		this.namespace = namespace;
	}

	public BundleCapabilityFilter namespace(String namespace) {
		setNamespace(namespace);
		return this;
	}
	
}
