/*-
 * ~~~~~~licensing~~~~~~
 * adapters-core
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.management;

import javax.management.NotCompliantMBeanException;
import javax.management.StandardMBean;

import ru.entaxy.esb.platform.base.management.core.api.EntaxyRuntimeTyped;
import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.api.Adapter;

//@TODO move string to constant
@EntaxyRuntimeTyped(name = "entaxy.runtime.adapter")
public class AdapterMBeanImpl extends StandardMBean implements AdapterMBean {
	
	protected Adapter adapter;
	
	public AdapterMBeanImpl(Adapter adapter) throws NotCompliantMBeanException {
		super(AdapterMBean.class);
		this.adapter = adapter;
	}
	
	@Override
	public String getId() {
		return adapter.getId();
	}

	@Override
	public boolean isInited() {
		return adapter.isInited();
	}

	@Override
	public String getName() {
		return adapter.getName();
	}

	@Override
	public String getDescription() {
		return adapter.getDescription();
	}
	
	
}
