/*-
 * ~~~~~~licensing~~~~~~
 * adapters-core
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.tracker;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleEvent;
import org.osgi.util.tracker.BundleTracker;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.api.Adapter;
import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.impl.DefaultAdapter;

import java.util.Optional;

public class AdapterTracker extends BundleTracker {
	
	protected static final Logger log = LoggerFactory.getLogger(AdapterTracker.class);
	
	protected AdapterHelper helper;
	
	@SuppressWarnings("unchecked")
	public AdapterTracker(BundleContext bundleContext) {
		super(bundleContext, Bundle.ACTIVE, null);
		this.helper = new AdapterHelper(bundleContext);
	}
	
	@Override
	public Object addingBundle(Bundle bundle, BundleEvent event) {
		String isAdapter = bundle.getHeaders().get(Adapter.ADAPTER_HEADER_NAME);
		if (Boolean.valueOf(isAdapter)) {
			String className = Optional.ofNullable(bundle.getHeaders().
					get(Adapter.ADAPTER_CLASS_HEADER_NAME)).orElse(DefaultAdapter.class.getName());
			log.debug("Adapter class " + className + " FOUND IN BUNDLE " + bundle.getSymbolicName());
			helper.create(bundle, className);
		}
		return bundle;
	}
}
