/*-
 * ~~~~~~licensing~~~~~~
 * adapters-core
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.tracker;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import javax.management.DynamicMBean;
import javax.management.MBeanRegistration;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.management.AdaptersMBean;
import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.management.AdaptersMBeanImpl;

public class AdapterTrackerActivator implements BundleActivator {

	protected static final Logger log = LoggerFactory.getLogger(AdapterTrackerActivator.class);
	
	protected AdapterTracker tracker;
	
	@Override
	public void start(BundleContext context) throws Exception {
		tracker = new AdapterTracker(context);
		tracker.open();
		/* AdaptersMBeanImpl mbean = new AdaptersMBeanImpl();
		Hashtable props = new Hashtable();
        props.put("jmx.objectname", "ru.entaxy.esb:type=bundle,name=adapters");
        List<String> list = new ArrayList<>();
        list.add(AdaptersMBean.class.getName());
        list.add(DynamicMBean.class.getName());
        list.add(MBeanRegistration.class.getName());
        String[] clazzes = list.toArray(new String[] {});
        context.registerService(
        		clazzes
        	, mbean
        	, props);*/		
	}

	@Override
	public void stop(BundleContext context) throws Exception {
		tracker.close();
	}

}
