[#ftl attributes={"generated.type":"blueprint"}]
<?xml version="1.0" encoding="UTF-8"?>
<blueprint xmlns="http://www.osgi.org/xmlns/blueprint/v1.0.0"
           xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
           xmlns:cm="http://aries.apache.org/blueprint/xmlns/blueprint-cm/v1.1.0"
           xsi:schemaLocation="
               http://www.osgi.org/xmlns/blueprint/v1.0.0 https://www.osgi.org/xmlns/blueprint/v1.0.0/blueprint.xsd"
           >

    <service interface="org.apache.camel.Component" ref="[=objectId]">
        <service-properties>
            <entry key="connection.name" value="[=objectId]"/>
        </service-properties>
    </service>

	[#if properties??]
		[#if properties.ext_createResourceProvider??]
			[#if properties.ext_createResourceProvider]
	<!-- RESOURCE PROVIDER BEAN -->
	<bean id="[=objectId].resourceProvider" class="ru.entaxy.esb.resources.provider.FileResourceProvider">
		<property name="protocol" value="[=objectId]" />
		<property name="rootDirectory" value="[=properties.rootDirectory]" />
				[#if properties.ext_ignoreFolders??]
		<property name="ignoreFolders" value="[=properties.ext_ignoreFolders]" />
				[/#if]
				[#if properties.ext_ignoreResources??]
		<property name="ignoreResources" value="[=properties.ext_ignoreResources]" />
				[/#if]
	</bean>

    <service interface="ru.entaxy.esb.resources.EntaxyResourceProvider" ref="[=objectId].resourceProvider">
        <service-properties>
            <entry key="connection.name" value="[=objectId]"/>
            <entry key="protocol" value="[=objectId]"/>
        </service-properties>
    </service>
			[/#if]	
		[/#if]
	[/#if]

    <bean id="[=objectId]" class="ru.entaxy.platform.adapter.file.ExtendedFileComponent">
        [#if properties??]
        	[#list properties as key, value]
        		[#if !key?starts_with("##") && !key?starts_with("__") && !key?starts_with("ext_")] [#-- we skip additional properties --]
	        		[#if key?starts_with("file_")] [#-- we add parent component properties --]
		<property name="[=key[5..]]" value="[=value]"/>
					[#else]        		
        <property name="[=key]" value="[=value]"/>
        			[/#if]
        		[/#if]
        	[/#list]
        [/#if]
    </bean>

</blueprint>
