/*-
 * ~~~~~~licensing~~~~~~
 * connection-producer
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.connecting.producer.connection;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.api.Adapter;
import ru.entaxy.esb.platform.runtime.base.connecting.connection.Connection;
import ru.entaxy.esb.platform.runtime.base.connecting.connection.ConnectionImpl;
import ru.entaxy.esb.platform.runtime.base.connecting.producer.Producer;

import java.util.HashMap;
import java.util.Map;

public class ConnectionProducer implements Producer {

    private static final Logger log = LoggerFactory.getLogger(ConnectionProducer.class);
    private static final Map<String,Adapter> adapterMap = new HashMap<>();

    @Override
    public Connection createConnection(JsonObject jsonConnection) {
        return new Gson().fromJson(jsonConnection, ConnectionImpl.class);
    }

    @Override
    public Connection useConnection(JsonObject jsonConnection) {
        return null;
    }

}
