/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.base.objects.shell;

import org.apache.karaf.shell.api.action.Command;
import org.apache.karaf.shell.api.action.lifecycle.Service;
import org.apache.karaf.shell.support.table.ShellTable;

import ru.entaxy.platform.base.objects.EntaxyObject;

@Service
@Command(name = "object-relations", scope = EntaxyObjectServiceSupport.OBJECTS_SCOPE)
public class ObjectRelations extends ObjectAwareCommand {

	@Override
	public Object doExecute() throws Exception {
		
		ShellTable shellTable = new ShellTable();
		shellTable.column("Name");
		shellTable.column("Type");
		shellTable.column("Scope");
		shellTable.column("Target");
		shellTable.column("Subord");
		shellTable.column("Group");
		
		for (EntaxyObject.Relation relation: entaxyObject.getRelations()) 
			shellTable.addRow().addContent(
				relation.getName(),
				relation.getType().name(),
				relation.getScope().name(),
				relation.getTarget().getObjectFullId(),
				(relation.isSubordinating()?"*":""),
				relation.getGroup()
			);
		
		shellTable.print(System.out);

		return null;
	}

}
