/*-
 * ~~~~~~licensing~~~~~~
 * resources-service
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.resources.impl;

import java.util.List;

import ru.entaxy.esb.resources.EntaxyResourceProcessor;
import ru.entaxy.esb.resources.EntaxyResourceProviderProxy;

public abstract class AbstractResourceProviderProxy implements EntaxyResourceProviderProxy {

	protected String protocol;
	protected String targetProtocol;
	protected String targetPath;
	
	protected List<EntaxyResourceProcessor> processors;
	
	@Override
	public String getProtocol() {
		return protocol;
	}

	@Override
	public String getTargetProtocol() {
		return targetProtocol;
	}

	@Override
	public String getTargetPath() {
		return targetPath;
	}

	public List<EntaxyResourceProcessor> getProcessors() {
		return processors;
	}

	public void setProcessors(List<EntaxyResourceProcessor> processors) {
		this.processors = processors;
	}

	public void setProtocol(String protocol) {
		this.protocol = protocol;
	}

	public void setTargetProtocol(String targetProtocol) {
		this.targetProtocol = targetProtocol;
	}

	public void setTargetPath(String targetPath) {
		this.targetPath = targetPath;
	}
	
}
