/*-
 * ~~~~~~licensing~~~~~~
 * resources-service
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.resources.impl.service;

import java.util.List;

import ru.entaxy.esb.resources.EntaxyResource;
import ru.entaxy.esb.resources.EntaxyResourceProcessor;
import ru.entaxy.esb.resources.EntaxyResourceProviderProxy;
import ru.entaxy.esb.resources.EntaxyResourceService;
import ru.entaxy.esb.resources.impl.AbstractResourceProvider;

public class ProxyProvider extends AbstractResourceProvider {
	
	protected EntaxyResourceProviderProxy proxy;
	protected EntaxyResourceService resourceService;
	
	protected String prefix;
	
	public ProxyProvider(EntaxyResourceService resourceService, EntaxyResourceProviderProxy proxy) {
		super();
		this.resourceService = resourceService;
		this.proxy = proxy;
		this.prefix = proxy.getTargetProtocol() + ":" + proxy.getTargetPath();
		if (!this.prefix.endsWith("/") && !this.prefix.endsWith(":"))
			this.prefix += "/";
	}
	
	@Override
	public String getProtocol() {
		return this.proxy.getProtocol();
	}
	
	@Override
	protected EntaxyResource doGetResource(String location) {
		return resourceService.getResource(this.prefix + location);
	}
	@Override
	protected List<EntaxyResource> doGetResources(String location) {
		return resourceService.getResources(this.prefix + location);
	}
	
	@Override
	public List<EntaxyResourceProcessor> getProcessors() {
		return proxy.getProcessors();
	}

}
