/*-
 * ~~~~~~licensing~~~~~~
 * artifact-management
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.artifact.installer.builder.impl.cluster;

import ru.entaxy.platform.core.artifact.DeployedArtifact;
import ru.entaxy.platform.core.artifact.installer.builder.ClusterInstaller;
import ru.entaxy.platform.core.artifact.installer.builder.InstallationResult;
import ru.entaxy.platform.core.artifact.installer.builder.LocalInstaller;
import ru.entaxy.platform.core.artifact.installer.builder.typed.TypedInstaller;
import ru.entaxy.platform.core.artifact.legacy.BundleController;

public class ClusterInstallerWrapperImpl implements ClusterInstaller {
	
	protected LocalInstaller delegate;
	
	public ClusterInstallerWrapperImpl(LocalInstaller delegate) {
		this.delegate = delegate;
	}

	@Override
	public ClusterInstaller artifact(DeployedArtifact artifact) {
		this.delegate.artifact(artifact);
		return this;
	}

	@Override
	public ClusterInstaller sourceLocation(String sourceLocation) {
		this.delegate.sourceLocation(sourceLocation);
		return this;
	}

	@Override
	public ClusterInstaller bundleName(String bundleName) {
		this.delegate.bundleName(bundleName);
		return this;
	}

	@Override
	public <T extends TypedInstaller> T typed(Class<T> type) {
		return this.delegate.typed(type);
	}

	@Override
	public BundleController bundleController() {
		return this.delegate.bundleController();
	}

	@Override
	public InstallationResult install() {
		return this.delegate.install();
	}

	@Override
	public InstallationResult uninstall() {
		return this.delegate.uninstall();
	}

	@Override
	public ClusterInstaller groups(String... groups) {
		// NOOP
		return this;
	}
	
}
