/*-
 * ~~~~~~licensing~~~~~~
 * artifact-management
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.artifact.installer.builder.impl.cluster;

import java.util.ArrayList;
import java.util.List;

import org.apache.karaf.cellar.core.GroupManager;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ru.entaxy.platform.base.support.osgi.OSGIUtils;
import ru.entaxy.platform.core.artifact.installer.builder.typed.impl.TypedInstallerHelper;

public class ClusterTypedInstallerHelper extends TypedInstallerHelper {

	private static final Logger log = LoggerFactory.getLogger(ClusterTypedInstallerHelper.class);
	
	protected List<String> groups = new ArrayList<>();

	public void setGroups(List<String> groups) {
		this.groups = groups;
	}
	
	public List<String> getGroups() {
		return groups;
	}

	protected boolean checkGroup(String groupName) {
		GroupManager groupManager = OSGIUtils.getService(GroupManager.class);
		if (groupManager == null)
			try {
				groupManager = OSGIUtils.services().ofClass(GroupManager.class).waitService(20000).<GroupManager>get();
				if (groupManager == null)
					throw new Exception("Service not found in 20000 ms");
			} catch (Exception e) {
				log.error("ERROR getting GroupManager service: ", e);
				return false;
			}
		return (groupManager.findGroupByName(groupName) != null);
	} 
	
}
