/*-
 * ~~~~~~licensing~~~~~~
 * artifact-management
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.artifact.repository.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class RepositoryConfigurableHelper extends RepositoryDescriptor {

	private static final List<RepositoryConfigurableHelper> helpers = new ArrayList<>(); 
	
	private static final Logger log = LoggerFactory.getLogger(RepositoryConfigurableHelper.class);
	
	RepositoryConfigurableHelperCollector collector;

	public void init() {
		if (collector != null)
			collector.addConfigurableHelper(this);
		log.info("Helper with name [{}] created", name);
		RepositoryConfigurableHelper.helpers.add(this);
		log.info("Total helpers: {}:\n{}", 
				"" + RepositoryConfigurableHelper.helpers.size(),
				RepositoryConfigurableHelper.helpers.stream()
						.map((h)->h.getName()).collect(Collectors.joining("\n\t", "\t", "")));
	}
	
	public void setCollector(RepositoryConfigurableHelperCollector collector) {
		this.collector = collector;
	}
	
}
