/*-
 * ~~~~~~licensing~~~~~~
 * schema-api
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.core.infrastructure.schema.api;

import ru.entaxy.esb.platform.runtime.core.infrastructure.schema.api.entity.Resource;
import ru.entaxy.esb.platform.runtime.core.infrastructure.schema.api.entity.ResourceInfo;

import java.util.List;
import java.util.Optional;

public interface ResourceService {

    long loadResource(Resource resource);

    long reloadResource(Resource resource);

    Optional<Resource> getResource(long id);

    Optional<Resource> getResourceByNamespace(String namespace);

    Optional<Resource> getResourceByName(String name);

    Optional<Resource> getResourceByFullName(String name);

    Optional<Resource> getResourceByIdAndVersion(long id, String version);

    void removeResource(long id);

    long loadResourceInfo(ResourceInfo resourceInfo);

    long editResourceInfo(ResourceInfo resourceInfo);

    Optional<ResourceInfo> getResourceInfo(long id);

    Optional<ResourceInfo> getResourceInfoByNamespace(String namespace);

    Optional<ResourceInfo> getResourceInfoByName(String name);

    Optional<ResourceInfo> getResourceInfoByIdAndVersion(long id, String version);

    void removeResourceInfo(long id);

    List<ResourceInfo> getListResourceInfo();

    List<ResourceInfo> getListResourceInfoByName(String name);

    List<ResourceInfo> getResourceInfoByFullName(String name);

    List<ResourceInfo> getResourceInfoByPath(String path);

    List<ResourceInfo> getResourceInfoByFullPath(String path);

    List<ResourceInfo> getListResourceInfoByNamespace(String namespace);

}
