/*-
 * ~~~~~~licensing~~~~~~
 * schema-soap
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.core.infrastructure.schema.soap.mapper;

import org.mapstruct.Mapping;
import org.mapstruct.Mappings;
import ru.entaxy.esb.platform.runtime.core.infrastructure.schema.api.entity.Resource;
import ru.entaxy.esb.platform.runtime.core.infrastructure.schema.api.entity.ResourceInfo;
import ru.entaxy.esb.platform.runtime.core.infrastructure.schema.soap.cxf.*;

@org.mapstruct.Mapper
public interface ResourceMapper {

    @Mappings({
            @Mapping(target = "createdDate", expression = "java(new java.util.Date())"),
            @Mapping(target = "resourceId", source = "idResource"),
    })
    ResourceInfo toResourceInfo(ResourceInfoType resourceInfoType);

    @Mappings({
            @Mapping(source = "resourceId", target = "idResource"),
    })
    ResourceInfoFullType toResourceInfoFullType(ResourceInfo resourceInfo);

    @Mappings({
            @Mapping(target = "resourceId", source = "idResource"),
            @Mapping(target = "editedDate", expression = "java(new java.util.Date())"),
    })
    ResourceInfo editedResourceInfoFullTypeResourceInfo(EditedResourceInfoFullType resourceInfoFullType);

    @Mappings({
            @Mapping(target = "createdDate", expression = "java(new java.util.Date())"),
            @Mapping(target = "resourceValue", source = "resourceValue"),
    })
    Resource toResource(LoadResourceType request);

    @Mappings({
            @Mapping(target = "editedDate", expression = "java(new java.util.Date())"),
    })
    Resource toEditedResource(ResourceType request);

    @Mappings({
            @Mapping(source = "resourceValue", target = "resourceValue"),
    })
    FullResourceType toFullResourceType(Resource resource);
}
