/*-
 * ~~~~~~licensing~~~~~~
 * profile-management
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.core.management.profile.impl.helper;

import org.osgi.service.component.annotations.Component;
import org.osgi.service.component.annotations.Reference;
import org.osgi.service.component.annotations.ReferenceCardinality;

import ru.entaxy.esb.platform.core.management.profile.impl.ProfileHelper;
import ru.entaxy.esb.platform.core.management.profile.impl.connector.ConnectorHelper;
import ru.entaxy.esb.platform.core.management.profile.impl.permission.PermissionHelper;
import ru.entaxy.esb.system.auth.basic.jpa.api.BasicAuthService;
import ru.entaxy.esb.system.jpa.SystemService;
import ru.entaxy.platform.base.objects.EntaxyObjectService;

@Component (service = Helpers.class, immediate = true)
public class Helpers {

	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public ProfileHelper profileHelper; 
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public ConnectorHelper connectorHelper;
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public BasicAuthService basicAuthService;
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public SystemService systemService;
	
	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public PermissionHelper permissionHelper;

	@Reference (cardinality = ReferenceCardinality.MANDATORY)
	public EntaxyObjectService entaxyObjectService;
}
