/*-
 * ~~~~~~licensing~~~~~~
 * object-producer-core
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.executor.generationmodel;

import java.util.Map;

import ru.entaxy.platform.base.objects.EntaxyObject;
import ru.entaxy.platform.core.producer.api.EntaxyProducerService;
import ru.entaxy.platform.core.producer.api.ProducerResult;
import ru.entaxy.platform.core.producer.api.ProducerResult.CommandResult;
import ru.entaxy.platform.core.producer.executor.objectmodel.FactoredObjectProxy;

public class ResolveObjectTask extends AbstractTask {

	public FactoredObjectProxy origin;
	
	public EntaxyObject targetObject;
	
	public ResolveObjectTask(FactoredObjectProxy object) {
		super();
		this.origin = object;
	}
	
	@Override
	public String getInfo() {
		return "RESOLVE-OBJECT " 
				+ "[" 
				+ origin.getObjectId() 
				+ " : " 
				+ origin.getObjectType() 
				+ "]"; 
				// + objectRef.factoryId;
	}
	@Override
	public boolean execute(ProducerResult currentResult, CommandResult currentCommand,
			EntaxyProducerService producerService, Map<String, Object> instructions) throws Exception {
		
		String targetId = origin.getObjectId();
		String targetType = origin.getObjectType();
		
		this.targetObject = ObjectResolveHelper.getInstance().findObject(targetId, targetType);
		
		if (this.targetObject == null) {
			throw new IllegalArgumentException("Object not found: " + targetId + ":" + targetType);
		}
		
		return true;
	}

}
