/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.impl;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import ru.entaxy.esb.platform.runtime.base.connecting.generator.Generated;
import ru.entaxy.platform.base.objects.EntaxyObject.FIELDS;
import ru.entaxy.platform.base.objects.factory.EntaxyFactoryException;
import ru.entaxy.platform.core.producer.api.EntaxyWrappedFactory;
import ru.entaxy.platform.core.producer.wrapper.AbstractFactoryWrapper;
import ru.entaxy.platform.core.producer.wrapper.AbstractFactoryWrapper.GenerationProcessor;

public class CommonObjectProducer extends DefaultProducer implements GenerationProcessor {
	
	protected final Map<String, String> defaultFieldsPublished = new HashMap<>() {
		private static final long serialVersionUID = 1L;

	{
		put(FIELDS.OBJECT_ID, FIELDS.OBJECT_ID);
	}}; 
	
	protected Map<String, String> getFieldsToPublish(String outputType, String scope, String objectType, String objectId){
		return defaultFieldsPublished;
	}
	
	@Override
	protected void addFields(AbstractFactoryWrapper factoryWrapper) {
		super.addFields(factoryWrapper);
		/*factoryWrapper.addField(
				(new FieldInfoImpl())
				.name(FIELDS.OBJECT_ID)
				.type("String")
				.required(true)
				.immutable(true)
					);
		*/
	}

	@Override
	public void postGenerate(EntaxyWrappedFactory wrappedFactory, String outputType, String scope, String objectType, Map<String, Object> parameters,
			Generated generated) throws EntaxyFactoryException {
		
		String objectId = parameters.getOrDefault(FIELDS.OBJECT_ID, "").toString();
		
		Map<String, String> publishedFields = getFieldsToPublish(outputType, scope, objectType, objectId);
		
		Map<String, Object> dataToPublish = new HashMap<>();
		
		if (parameters.containsKey(FIELDS.FIELDS_TO_PUBLISH)) {
			Object obj = parameters.get(FIELDS.FIELDS_TO_PUBLISH);
			if (obj instanceof Map) {
				Map<String, Object> ownData = (Map)obj;
				dataToPublish.putAll(ownData);
			}
		}
		
		for (Entry<String, String> entry: publishedFields.entrySet())
			dataToPublish.put(entry.getKey(), generated.getProperties().get(entry.getValue()));
		
		generated.getProperties().put(FIELDS.FIELDS_TO_PUBLISH, new HashMap<String, Map<String, Object>>() {{
			put(objectId, dataToPublish);
		}});
	}
	
}
