/*-
 * ~~~~~~licensing~~~~~~
 * object-producer-core
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.support;

import java.util.Map;

public class MetadataStorageWrapper extends AbstractConsumerAwareMetadataStorage implements MetadataStorage {

	protected MetadataStorage origin;
	protected MetadataStorage empty = new MetadataStorageEmpty();
	
	public MetadataStorage getOrigin() {
		return origin;
	}

	public void setOrigin(MetadataStorage origin) {
		this.origin = origin;
	}

	protected MetadataStorage getStorage() {
		if (origin != null)
			return origin;
		return empty;
	}
	
	@Override
	public Map<String, String> getStrings() {
		return getStorage().getStrings();
	}

	@Override
	public Map<String, Boolean> getBooleans() {
		return getStorage().getBooleans();
	}

	@Override
	public Map<String, Number> getNumbers() {
		return getStorage().getNumbers();
	}

	@Override
	public Map<String, Object> getAllData() {
		return getStorage().getAllData();
	}

}
