/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.wrapper;

import java.util.Map;

import ru.entaxy.esb.platform.runtime.base.connecting.generator.Generated;
import ru.entaxy.platform.base.objects.factory.EntaxyFactory;
import ru.entaxy.platform.base.objects.factory.EntaxyFactoryException;
import ru.entaxy.platform.core.producer.api.EntaxyWrappedFactory;

public abstract class AbstractFactoryWrapper implements EntaxyWrappedFactory {

	public static interface GenerationProcessor {
		
		String PROP_PROCESSOR_ID = "generation.plugin.id";
		String PROP_FACTORY_TYPE = "generation.factory.type";
		
		public default void preGenerate(EntaxyWrappedFactory wrappedFactory, String outputType, String scope
				, String objectType, Map<String, Object> parameters)  throws EntaxyFactoryException{
			
		};
		
		public default void postGenerate(EntaxyWrappedFactory wrappedFactory, String outputType, String scope
				, String objectType, Map<String, Object> parameters, Generated generated)  throws EntaxyFactoryException{
			
		};
		
	}

	protected GenerationProcessor generationProcessor = null;
	
	public AbstractFactoryWrapper(EntaxyFactory origin) {
		super();
	}

	public void setGenerationProcessor(GenerationProcessor generationProcessor) {
		this.generationProcessor = generationProcessor;
	}

	@Deprecated
	public abstract void addField(FieldInfo fieldInfo);

	public abstract void addField(String outputType, FieldInfo fieldInfo);

}
