/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.wrapper;

import com.google.gson.JsonObject;

import ru.entaxy.platform.base.objects.factory.EntaxyFactory.FieldInfo;
import ru.entaxy.platform.core.producer.impl.EntaxyFactoryDataProcessorService;

public class FieldWrapper implements FieldInfo {

	protected FieldInfo origin;
	
	public FieldWrapper(FieldInfo origin) {
		this.origin = origin;
	}

	@Override
	public String getName() {
		return origin.getName();
	}

	@Override
	public String getType() {
		return origin.getType();
	}

	@Override
	public String getDisplayName() {
		return origin.getDisplayName();
	}

	@Override
	public String getDescription() {
		return origin.getDescription();
	}

	@Override
	public boolean isImmutable() {
		return origin.isImmutable();
	}

	@Override
	public boolean isRequired() {
		return origin.isRequired();
	}

	@Override
	public Object getDefaultValue() {
		return EntaxyFactoryDataProcessorService.getInstance().processDefaultValue(origin.getDefaultValue());
	}

	@Override
	public boolean isConditional() {
		return origin.isConditional();
	}

	@Override
	public String getCondition() {
		return origin.getCondition();
	}

	@Override
	public boolean isRef() {
		return origin.isRef();
	}

	@Override
	public JsonObject getJsonOrigin() {
		try {
			return origin.getJsonOrigin().deepCopy();
		} catch (Exception e) {
			return new JsonObject();
		}
	}
	
	
}
