/*-
 * ~~~~~~licensing~~~~~~
 * object-producing-resources-support
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.resources.formatters;

import java.util.Base64;

import org.osgi.service.component.annotations.Component;

import ru.entaxy.platform.core.producer.resources.EntaxyResourceStringFormatter;

@Component (service = EntaxyResourceStringFormatter.class, immediate = true)
public class Base64Formatter implements EntaxyResourceStringFormatter {

	@Override
	public String getName() {
		return "base64";
	}

	@Override
	public String format(String value) {
		return new String(Base64.getEncoder().encode(value.getBytes()));
	}

	@Override
	public String unformat(String value) {
		return new String(Base64.getDecoder().decode(value));
	}
	
}
