/*-
 * ~~~~~~licensing~~~~~~
 * basic-auth-api
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.auth.basic.jpa.api;

import ru.entaxy.esb.system.auth.basic.jpa.api.entity.BasicAuthAccount;
import ru.entaxy.esb.system.auth.basic.jpa.api.exception.BadPasswordException;

import java.security.NoSuchAlgorithmException;
import java.util.List;
import java.util.Optional;

public interface BasicAuthService {

    List<BasicAuthAccount> list();

    Optional<BasicAuthAccount> get(String login);
    
    Optional<BasicAuthAccount> getBySystem(String systemUuid);

    Optional<BasicAuthAccount> getByAuthorizationHeaderHash(String authorizationHeaderHash);

    BasicAuthAccount save(BasicAuthAccount basicAuthAccount, boolean isExist);

    public BasicAuthAccount saveFull(String login, String passwordHash, String encryptionAlgorithm, String systemUUID,
                                     String authorizationHeaderHash, String description, String createdBy, String editedBy);

    BasicAuthAccount saveCommon(String login, String passwordHash, String systemUUID, String createdBy, String editedBy)
            throws NoSuchAlgorithmException, BadPasswordException;

    BasicAuthAccount saveShort(String login, String passwordHash, String createdBy, String editedBy) throws NoSuchAlgorithmException, BadPasswordException;

    void remove(String login);

    boolean check(String login, String password);

}
