/*-
 * ~~~~~~licensing~~~~~~
 * basic-auth-api
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.auth.basic.jpa.api.entity.field;

import java.util.Arrays;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

public enum EncryptionAlgorithm {

    PLAIN("PLAIN"),
    MD5("MD5"),
    SHA1("SHA-1"),
    SHA256("SHA-256"),
    SHA384("SHA-384"),
    SHA512("SHA-512");

    private static Map<String, EncryptionAlgorithm> map = null;
    private final String name;

    EncryptionAlgorithm(String name) {
        this.name = name;
    }

    public String getAlgorithmName() {
        return name;
    }

    public boolean equalsName(String checkingName) {
        return checkingName != null && this.name.equals(checkingName.toUpperCase());
    }

    public static EncryptionAlgorithm getByName(String name) {
        return map.get(name.toUpperCase());
    }

    static {
        map = Arrays.stream(EncryptionAlgorithm.values())
                .collect(Collectors.toMap(EncryptionAlgorithm::getAlgorithmName, Function.identity()));
    }
}
