/*-
 * ~~~~~~licensing~~~~~~
 * events-api
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.core.events.jpa;

import ru.entaxy.esb.system.core.events.jpa.entity.EventTopic;

import java.util.List;
import java.util.Optional;

public interface EventTopicService {

    List<EventTopic> list();

    List<EventTopic> listByDeleted(boolean deleted);

    EventTopic get(long id);

    Optional<EventTopic> fetch(long id);

    EventTopic getByName(String name);

    Optional<EventTopic> fetchByName(String name);

    EventTopic getByNameAndDeleted(String name, boolean deleted);

    Optional<EventTopic> fetchByNameAndDeleted(String name, boolean deleted);

    EventTopic add(EventTopic eventTopic);

    EventTopic add(String name, String createdBy);

    EventTopic update(EventTopic eventTopic);

    EventTopic update(long id, String name, String editedBy);

    void remove(EventTopic eventTopic);

    void remove(long id);

    void markAsDeleted(long id, boolean deleted);

    int clean();

}
