/*-
 * ~~~~~~licensing~~~~~~
 * profile-commons
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.profile.commons;

import ru.entaxy.esb.system.profile.commons.profile_output.ProfileOutput;

import java.util.Objects;

public abstract class CommonProfile implements Profile {

    protected String systemName = "system";
    protected ProfileOutput profileOutput;
    protected InConnectorCollector inConnectorCollector;

    @Override
    public void send(Object request) {
        doSend(request);
    }

    protected abstract void doSend(Object request);

    @Override
    public String getSystemName() {
        return systemName;
    }

    public void setSystemName(String systemName) {
        this.systemName = systemName;
    }

    @Override
    public ProfileOutput getProfileOutput() {
        return profileOutput;
    }

    public void setProfileOutput(ProfileOutput profileOutput) {
        this.profileOutput = profileOutput;
    }

    public InConnectorCollector getInConnectorCollector() {
        return inConnectorCollector;
    }

    public void setInConnectorCollector(InConnectorCollector inConnectorCollector) {
        this.inConnectorCollector = inConnectorCollector;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        CommonProfile that = (CommonProfile) o;
        return Objects.equals(systemName, that.systemName);
    }

    @Override
    public int hashCode() {
        return Objects.hash(systemName);
    }

    @Override
    public String toString() {
        return "CommonProfile{" +
                "systemName='" + systemName + '\'' +
                '}';
    }
}
