/*-
 * ~~~~~~licensing~~~~~~
 * bundle-manager
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.system.management.bundle.manager;

import ru.entaxy.esb.system.management.bundle.jpa.dto.BundleDto;
import ru.entaxy.platform.core.blueprint.generator.Blueprint;

import java.net.URL;
import java.util.Map;

public interface BundleManager {

    BundleDto installAndStartBundle(String bundleName, String bundleType, String bundleVersion,
                                    Map<String, String> param) throws Exception;
    
    BundleDto installBundle(String bundleName, String templateName, String templateFileName, String bundleType, String bundleVersion,
			URL templateUrl, Map<String, String> param) throws Exception;
    
    BundleDto installAndStartBundle(String bundleName, String bundleType, String bundleVersion, Blueprint blueprint) throws Exception;
    
    BundleDto installBundle(String bundleName, String bundleType, String bundleVersion, Blueprint blueprint) throws Exception;

    BundleDto installAndStartBundle(String bundleName, String bundleType, String bundleVersion) throws Exception;

    BundleDto installBundle(String bundleName, String bundleType, String bundleVersion) throws Exception;

    BundleDto startBundle(BundleDto bundle) throws Exception;

    BundleDto stopBundle(BundleDto bundle) throws Exception;

    void startBundle(String bundleName) throws Exception;

    void stopBundle(String bundleName) throws Exception;

    void uninstallBundle(String bundleName, String type, String bundleVersion) throws Exception;

    BundleDto installAndStartBundle(String bundleName, String templateName, String templateFileName, String bundleType, String bundleVersion,
                                    URL url, Map<String, String> param) throws Exception;
    
    BundleDto installBundle(String bundleName, String bundleType, String bundleVersion, Map<String, String> param)
			throws Exception;

    void uninstallBundleByName(String bundleName, String type, String bundleVersion) throws Exception;

	void restore(BundleDto bundle) throws Exception;

	void checkCurrentBundleStatus(BundleDto bundle) throws Exception;

	

	

}
