/*-
 * ~~~~~~licensing~~~~~~
 * plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy1CCommunication;
(function (Entaxy1CCommunication) {
    Entaxy1CCommunication._module.component('entaxy1cCommunicationDemoSettingsModal', {
        bindings: {
            modalInstance: '<',
            resolve: '<'
        },
        template:
        `
            <div class="modal-header">
              <button type="button" class="close" aria-label="Close" ng-click="$ctrl.cancel()">
                <span class="pficon pficon-close" aria-hidden="true"></span>
              </button>
              <h4 class="modal-title">Настройки</h4>
            </div>

            <!-- // fixme style -->
            <div class="modal-body" style="height: 200px;">
              <form name="connectorForm" class="form-horizontal"> <!-- //fixme class -->
                <div class="form-group" ng-class="{'has-error': $ctrl.errors[formField.name]}"
                      ng-repeat="formField in $ctrl.formFields">
                  <div class="col-sm-4 label-col">
                    <label class="control-label" ng-class="{'required-pf': formField.required}" for="{{formField.name}}">{{formField.label}}</label>
                    <button type="button" class="btn btn-link label-description-popover" popover-placement="auto top-left" popover-trigger="'outsideClick'"
                          uib-popover="{{formField.description}}" ng-if="formField.description">
                      <span class="pficon pficon-help"></span>
                    </button>
                  </div>
                  <div class="col-sm-7">
                    <input type="{{formField.type}}" id="{{formField.name}}" ng-class="{'form-control': formField.type !== 'checkbox'}" ng-model="formField.value">
                    <span class="help-block" ng-show="$ctrl.errors[formField.name]">{{$ctrl.errors[formField.name]}}</span>
                  </div>
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <button type="submit" class="btn btn-primary" ng-click="$ctrl.save()">Сохранить</button>
            </div>
        `,
        controller: Entaxy1cCommunicationDemoSettingsModalController
    })
    .name;

    function Entaxy1cCommunicationDemoSettingsModalController(operationsService, entaxyService) {
        'ngInject';

        var ctrl = this;

        ctrl.$onInit = function () {

            let forwardedUser = ctrl.resolve.forwardedUser;
            let destinationId = ctrl.resolve.destinationId;

            ctrl.formFields = [];

            ctrl.formFields.push({
                label: 'Forwarded User',
                name: 'forwardedUser',
                type: 'java.lang.String',
                value: forwardedUser,
                required: true
            });

            ctrl.formFields.push({
                label: 'Destination Id',
                name: 'destinationId',
                type: 'java.lang.String',
                value: destinationId,
                required: true
            });

        }

        ctrl.cancel = function (reason) {
            ctrl.modalInstance.dismiss(reason);
        }

        ctrl.save = function () {
            ctrl.errors = validate();

            if (Object.keys(ctrl.errors).length === 0) {
                ctrl.modalInstance.close(ctrl.formFields.map((field) => { return { name: field.name, value: field.value }; }));
            }
        }

        function validate () {
            let errors = {};

            ctrl.formFields.forEach((field) => {
                if (field.required && (field.value === undefined || field.value.trim().length === 0)) {
                    errors[field.name] = 'Please fill out this field';
                }
            });

            return errors;
        }
    }
    Entaxy1cCommunicationDemoSettingsModalController.$inject = ['operationsService', 'entaxyService'];

})(Entaxy1CCommunication || (Entaxy1CCommunication = {}));
