/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
/**
 * The main entry point for the Simple module
 */
var Entaxy1CCommunication = (function (Entaxy1CCommunication) {

    /**
    * The name of this plugin
    */
    Entaxy1CCommunication.pluginName = 'entaxy-1c-communication';

    /**
    * This plugin's logger instance
    */
    Entaxy1CCommunication.log = Logger.get('entaxy-1c-communication');

    /**
    * The top level path of this plugin on the server
    */
    Entaxy1CCommunication.contextPath = "/entaxy-1c-communication/";

    Entaxy1CCommunication.log.info("loading entaxy 1c communication plugin")
    Entaxy1CCommunication._module = angular.module(Entaxy1CCommunication.pluginName, [
        'angularResizable'
    ])
    .component('entaxy1cCommunication', {
        template:
           `
           <entaxy-1c-communication-demo></entaxy-1c-communication-demo>
           `
    })
    .run(configurePlugin);

  function configurePlugin(mainNavService, workspace, helpRegistry, preferencesRegistry, localStorage, preLogoutTasks, documentBase, $templateCache) {
        var entaxy1CCommunicationJmxDomain = localStorage['entaxy1CCommunicationJmxDomain'] || "ru.entaxy.1c.communication";
        mainNavService.addItem({
            title: 'Тестовое Приложение',
            basePath: '/1c-communication',
            template: '<entaxy-1c-communication></entaxy-1c-communication>',
            isValid: function () { return workspace.treeContainsDomainAndProperties(entaxy1CCommunicationJmxDomain); }
        });
        // clean up local storage upon logout
        /*preLogoutTasks.addTask('CleanupArtemisCredentials', function () {
            Artemis.log.debug("Clean up Artemis credentials in local storage");
            localStorage.removeItem('artemisUserName');
            localStorage.removeItem('artemisPassword');
        });*/
    }
    configurePlugin.$inject = ['mainNavService', 'workspace', 'helpRegistry', 'preferencesRegistry', 'localStorage', 'preLogoutTasks', 'documentBase', '$templateCache'];

  return Entaxy1CCommunication;

})(Entaxy1CCommunication || {});

// tell the Hawtio plugin loader about our plugin so it can be
// bootstrapped with the rest of AngularJS
hawtioPluginLoader.addModule(Entaxy1CCommunication.pluginName);
