/*-
 * ~~~~~~licensing~~~~~~
 * plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy1CCommunication;
(function (Entaxy1CCommunication) {
    Entaxy1CCommunication._module.factory('xml2JsonService', [
        function() {
            return {
                xml2json: function (xml) {
                    return xml2json(xml);
                }
            };

            function xml2json(xml) {
                let result = {};
                let parser = new DOMParser();
                let xmlDoc = parser.parseFromString(xml, "text/xml");

                xmlDoc.childNodes.forEach((node) => {
                    parseNode(node, result);
                });

                return result;
            }

            function parseNode(xmlNode, result) {
                if (xmlNode.nodeName == "#text") {
                    let value = xmlNode.nodeValue;
                    if (value.trim()) {
                        result['#text'] = value;
                    }
                    return;
                }

                let jsonNode = {};
                let existing = result[xmlNode.nodeName];
                if (existing) {
                    if (!Array.isArray(existing)) {
                        result[xmlNode.nodeName] = [existing, jsonNode];
                    } else {
                        result[xmlNode.nodeName].push(jsonNode);
                    }
                } else {
                    result[xmlNode.nodeName] = [jsonNode];
                }

                if (xmlNode.attributes) {
                    angular.forEach(xmlNode.attributes, (attribute) => {
                        jsonNode[attribute.nodeName] = attribute.nodeValue;
                    });
                }

                xmlNode.childNodes.forEach((node) => {
                    parseNode(node, jsonNode);
                });
            }
        }
    ]);
})(Entaxy1CCommunication || (Entaxy1CCommunication = {}));
