/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.ui.hawtio.management;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import io.hawt.web.plugin.HawtioPlugin;

public class PluginContextListener implements ServletContextListener {

   private static final Logger log = LoggerFactory.getLogger(PluginContextListener.class);

   HawtioPlugin plugin = null;
	
	
	@Override
	public void contextInitialized(ServletContextEvent sce) {
	      ServletContext context = sce.getServletContext();

	      plugin = new HawtioPlugin();
	      plugin.setContext(context.getContextPath());
	      plugin.setName(context.getInitParameter("plugin-name"));
	      plugin.setScripts(context.getInitParameter("plugin-scripts"));
	      plugin.setDomain(null);

	      try {
	         plugin.init();
	      } catch (Exception e) {
	         throw createServletException(e);
	      }

	      log.info("Initialized {} plugin", plugin.getName());
	}

	@Override
	public void contextDestroyed(ServletContextEvent sce) {
	      try {
	          plugin.destroy();
	       } catch (Exception e) {
	          throw createServletException(e);
	       }

	       log.info("Destroyed {} plugin", plugin.getName());
	    }

    protected RuntimeException createServletException(Exception e) {
       return new RuntimeException(e);
    }

}
