/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module
    .component('entaxyCrumbs', {
        bindings: {
            rootCrumb: '<',
            crumbs: '='
        },
        template:
        `
          <div class="crumbs no-selection">
            <div class="crumb" ng-if="$ctrl.rootCrumb">
              <div class="crumb-info" ng-click="$ctrl.changeLocationToRoot()">
                {{$ctrl.rootCrumb}}
              </div>
              <span class="fa fa-angle-right" ng-if="$ctrl.crumbs.length > 0"></span>
            </div>
            <div class="crumb" ng-repeat="crumb in $ctrl.crumbs track by $index">
              <div class="crumb-info" ng-click="$ctrl.changeLocation(crumb)">
                {{crumb}}
              </div>
              <span class="fa fa-angle-right"></span>
            </div>
          </div>
        `,
        controller: entaxyCrumbsController
    })
    .name;

    function entaxyCrumbsController() {
        let ctrl = this;

        ctrl.changeLocationToRoot = function () {
            ctrl.crumbs = [];
        }

        ctrl.changeLocation = function (crumb) {
            let index = ctrl.crumbs.indexOf(crumb);
            ctrl.crumbs.length = index + 1;
        }
    }
})(Entaxy || (Entaxy = {}));
