/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module
    .component('entaxyUrlInput', {
        bindings: {
            model: '=',
            config: '<',
            formController: '<'
        },
        template:
        `
          <div class="input-with-button">
            <input type="text" ng-model="$ctrl.model" ng-class="{'form-control': true}" readonly>
            <button class="entaxy-view-resources-form" ng-click="$ctrl.openViewer()">Select...</button>
          </div>
        `,
        controller: entaxyUrlInputController
    })
    .name;

    function entaxyUrlInputController(workspace, $uibModal) {
        'ngInject';

        let ctrl = this;

        ctrl.openViewer = function() {

            $uibModal.open({
                component: 'entaxyResourceViewerModal',
                resolve: {
                    location: () => ctrl.model,
                    config: () => ctrl.config
                },
                size: 'xl',
                backdrop: 'static',
                windowTopClass: 'modal-top-margin-override'
            })
            .result.then(location => {
                if (ctrl.model !== location && ctrl.formController && !ctrl.formController.$dirty) {
                    ctrl.formController.$setDirty();
                }
                ctrl.model = location;
            });
        }
    }
    entaxyUrlInputController.$inject = ['workspace', '$uibModal'];

})(Entaxy || (Entaxy = {}));
