/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {

    function getAllBundleStates() {
        return JSON.parse('["Active", "Installed", "Resolved", "Starting", "Stopping", "Uninstalled"]');
    }
    Entaxy.getAllBundleStates = getAllBundleStates;

    function getConnectorTemplates() {
        return JSON.parse('["uniform-service-active-in-connector", "uniform-service-passive-in-connector", "uniform-service-active-out-connector", "uniform-service-passive-out-connector", "odata-in-connector", "sql-out-connector"]');
    }
    Entaxy.getConnectorTemplates = getConnectorTemplates;

    function getConnectorTemplateParams(templateName) {
        let json = JSON.parse(connectorTemplateParams);
        return json[templateName];
    }
    Entaxy.getConnectorTemplateParams = getConnectorTemplateParams;

    let connectorTemplateParams = '{"uniform-service-active-in-connector":[' +
        '{' +
            '"label":"period",' +
            '"displayName":"Period",' +
            '"type":"java.lang.String",' +
            '"helpText":null,' +
            '"value":"1m"' +
        '},' +
        '{' +
            '"label":"username",' +
            '"displayName":"Username",' +
            '"type":"java.lang.String",' +
            '"helpText":null,' +
            '"value":"admin"' +
        '},' +
        '{' +
            '"label":"password",' +
            '"displayName":"Password",' +
            '"type":"java.lang.String",' +
            '"helpText":null,' +
            '"value":""' +
        '},' +
        '{' +
            '"label":"endpointUrl",' +
            '"displayName":"Endpoint URL",' +
            '"type":"java.lang.String",' +
            '"helpText":null,' +
            '"value":""' +
        '},' +
        '{' +
            '"label":"connectionTimeout",' +
            '"displayName":"Connection Timeout",' +
            '"type":"int",' +
            '"helpText":null,' +
            '"value":3000' +
        '},' +
        '{' +
            '"label":"connectionMaxThreads",' +
            '"displayName":"Connection Max Threads",' +
            '"type":"int",' +
            '"helpText":null,' +
            '"value":1' +
        '}' +
    '],' +
    '"uniform-service-active-out-connector":[' +
        '{' +
            '"label":"username",' +
            '"displayName":"Username",' +
            '"type":"java.lang.String",' +
            '"helpText":null,' +
            '"value":"admin"' +
        '},' +
        '{' +
            '"label":"password",' +
            '"displayName":"Password",' +
            '"type":"java.lang.String",' +
            '"helpText":null,' +
            '"value":""' +
        '},' +
        '{' +
            '"label":"endpointUrl",' +
            '"displayName":"Endpoint URL",' +
            '"type":"java.lang.String",' +
            '"helpText":null,' +
            '"value":""' +
        '},' +
        '{' +
            '"label":"connectionTimeout",' +
            '"displayName":"Connection Timeout",' +
            '"type":"int",' +
            '"helpText":null,' +
            '"value":3000' +
        '},' +
        '{' +
            '"label":"connectionMaxThreads",' +
            '"displayName":"Connection Max Threads",' +
            '"type":"int",' +
            '"helpText":null,' +
            '"value":1' +
        '}' +
    '],' +
    '"uniform-service-passive-in-connector":[],' +
    '"uniform-service-passive-out-connector":[],' +
    '"odata-in-connector":[],' +
    '"sql-out-connector":[' +
        '{' +
        '"label":"serverName",' +
        '"displayName":"Server Name",' +
        '"type":"java.lang.String",' +
        '"helpText":null,' +
        '"value":""' +
        '},' +
        '{' +
        '"label":"portNumber",' +
        '"displayName":"Port Number",' +
        '"type":"java.lang.Integer",' +
        '"helpText":null,' +
        '"value":5432' +
        '},' +
        '{' +
        '"label":"databaseName",' +
        '"displayName":"Database Name",' +
        '"type":"java.lang.String",' +
        '"helpText":null,' +
        '"value":""' +
        '},' +
        '{' +
        '"label":"user",' +
        '"displayName":"User",' +
        '"type":"java.lang.String",' +
        '"helpText":null,' +
        '"value":""' +
        '},' +
        '{' +
        '"label":"password",' +
        '"displayName":"Password",' +
        '"type":"java.lang.String",' +
        '"helpText":null,' +
        '"value":""' +
        '},' +
        '{' +
        '"label":"dataSourceClass",' +
        '"displayName":"Data Source Class",' +
        '"type":"java.lang.String",' +
        '"helpText":null,' +
        '"value":"org.postgresql.ds.PGSimpleDataSource"' +
        '}' +
        ']' +
    '}';

})(Entaxy || (Entaxy = {}));
